﻿;handler for all i/o

Declare WC_RESTART()
Declare WC_SHOW_MAIN_SCREEN()
Declare WC_DELETE_MAP_OBJECT()
Declare WC_REDRAW_MENU_ELEMENTS(_void.l)
Declare WC_INFO()
Declare WC_ADD_MAP_OBJECT(_mode.l)

Procedure WC_TEMPLATE_HIDE()
  If  wc_template\is_valid=#True
    wc_template\transparency=10
     EndIf  
EndProcedure



Procedure WC_TEMPLATE_TRANSPARENCY_REMOVE()
  
  If  wc_template\is_valid=#True
    wc_template\transparency+10
    If wc_template\transparency>255
      wc_template\transparency=255
    EndIf
  EndIf
  
EndProcedure


Procedure WC_TEMPLATE_TRANSPARENCY_ADD()
  If  wc_template\is_valid=#True
    wc_template\transparency-10
    If wc_template\transparency<0
      wc_template\transparency=0
    EndIf
  EndIf  
EndProcedure


Procedure WC_LOAD_TEMPLATE_GFX(_path.s)
  
  If IsSprite(wc_template\id)
    FreeSprite(wc_template\id)  
    wc_template\is_valid=#False
  EndIf
  
  wc_template\id=LoadSprite(#PB_Any,_path.s,#PB_Sprite_AlphaBlending)
  If IsSprite(wc_template\id)
    wc_template\is_valid=#True
    wc_template\transparency=255
  Else
    wc_template\is_valid=#False
  EndIf
    
  EndProcedure


Procedure WC_LOAD_TEMPLATE()
  ;here we load the template to help building the map :
  ;you can use gfx as template and 
  Define _ok.l=0
Static _path.s=""
 _path.s= OpenFileRequester("LOAD MAP TEMPLATE",_path.s,"*",0)
  WC_LOAD_TEMPLATE_GFX(_path.s)
  
  EndProcedure


  Procedure    WC_FLIP_MAP_H()
    ;here we try a simple map rotation (we flip x y values...)
    Define _x.f=0
    Define _y.f=0
    
    ;here we go :
    
    If  ListSize(map_object())>0  ;there any objects?
      ResetList(map_object())
      
      While NextElement(map_object())
        
        _x.f=map_object()\_x
        _y.f=map_object()\_y
        map_object()\_x=_y.f
        map_object()\_y=_x.f
        
      Wend
      
    EndIf ;if no objects there is nothing to do
    
    
    
  EndProcedure



Procedure WC_SET_PROCEDURAL_WORK_GFX()
  
  If SelectElement(wc_menu_object(),ListIndex(wc_menu_object()))
        wc_work_gfx\_gfx_path=wc_menu_object()\_gfx_path
        wc_work_gfx\_ai_path=wc_menu_object()\_ai_path
        If IsSprite(wc_work_gfx\_gfx_id)
        FreeSprite(wc_work_gfx\_gfx_id)  
        EndIf
        
        wc_work_gfx\_gfx_id=LoadSprite(#PB_Any,wc_work_gfx\_gfx_path,#PB_Sprite_AlphaBlending)
        wc_work_with.l=SpriteWidth(wc_work_gfx\_gfx_id)
        wc_work_height.l=SpriteHeight(wc_work_gfx\_gfx_id)
        wc_work_gfx\_full_screen=wc_menu_object()\_full_screen
        wc_work_gfx\_raster_x=wc_work_with.l
        wc_work_gfx\_raster_y=wc_work_height.l
        wc_work_gfx\_transparency=255-wc_menu_object()\_transparency
        wc_work_gfx\_object_auto_layer=wc_menu_object()\_object_auto_layer
        wc_work_gfx\_alpha_blend=wc_menu_object()\_alpha_blend
        wc_work_gfx\object_is_procedural_base=wc_menu_object()\object_is_procedural_base
        wc_work_gfx\object_procedural_seed=wc_menu_object()\object_procedural_seed
        wc_work_gfx\object_procedural_source_name=wc_menu_object()\object_procedural_source_name
        wc_work_gfx\object_procedural_x_offset=wc_menu_object()\object_procedural_x_offset
        wc_work_gfx\object_procedural_y_offset=wc_menu_object()\object_procedural_y_offset
        wc_work_gfx\object_procedural_done=wc_menu_object()\object_procedural_done
        wc_work_gfx\object_shadow_intense=wc_menu_object()\object_shadow_intense
     
        
      EndIf
  
  EndProcedure


Procedure WC_PLACE_PROCEDURAL_OBJECT()
  
  Define _found.b=#False  
  
  ResetList(wc_menu_object())
  
  While NextElement(wc_menu_object()) And _found.b=#False 
    If map_object()\object_procedural_source_name=wc_menu_object()\object_internal_name And map_object()\object_procedural_done=#False  
      
      If Random(map_object()\object_procedural_seed)=0
      _found.b=#True  
      
      map_object()\object_procedural_done=#True
      If wc_menu_object()\object_internal_name>""
        WC_SET_PROCEDURAL_WORK_GFX()
        WC_ADD_MAP_OBJECT(#WC_AUTO_PLACE)
      EndIf 
    EndIf
    
    EndIf
  Wend
  
  
EndProcedure


Procedure WC_START_PROCEDURAL()
  ;here we try to create some map objects like foliage, trees,... automatically with the mapcreator
  ; we search For the entries with "object_is_procedural_base<>0"
  
  
  ResetList(map_object()) ;initial reset
  
  While NextElement(map_object())
    If map_object()\object_procedural_done=#False 
      WC_PLACE_PROCEDURAL_OBJECT()
      ResetList(map_object())  ;restart the list, because after generation we have added x listobjects, so we need to start the scan from the beginning to find all procedural tiles
    EndIf 
  Wend
  
  
EndProcedure  



Procedure  WC_CLEAN_CACHE( v_clean_cache_on_exit.b)
  
  If v_clean_cache_on_exit.b=#True
        DeleteDirectory(v_cache_dir.s,"")
  EndIf
  

EndProcedure



Procedure WC_GARBAGE_COLLECTOR()
  ;here we set all to start:
  
  ResetList(map_object())
  
  While NextElement(map_object())
    If IsSprite(map_object()\_gfx_id)
      
      FreeSprite(map_object()\_gfx_id)  ;we need to free the sprite memory bevore we free the list, because sprite(gfx) data is not released with FreeList()
      
    EndIf
  
  Wend
  
  ;now we free the list:
  
  FreeList(map_object())
  
  ;now rebirth:
  
Global NewList map_object.map_objects()
EndProcedure

Procedure WC_GET_AREA_ICON()
  Define _area_width.l=0 ;here we have the vars for the grab!  (64=default if no value ....)
  Define _area_height.l=0
  
  ;is there a buffer to free?
  If IsSprite(wc_area_file_icon.i)
    FreeSprite(wc_area_file_icon.i)   
  EndIf
  
  ;create the new buffer:
  If ListSize(map_object())>0
    
    ResetList(map_object())
    
    While NextElement(map_object())
      
      If _area_width.l<map_object()\_x
        _area_width.l=map_object()\_x
      EndIf
      
      If _area_height.l<map_object()\_y
        _area_height.l=map_object()\_y
      EndIf
      
    Wend
    
    If _area_height.l>v_window_h.l
      _area_height.l=v_window_h.l
    EndIf
    
    If _area_width.l>v_window_w.l
      _area_width.l=v_window_w.l
    EndIf
    
    wc_area_file_icon.i=GrabSprite(#PB_Any,0,0,_area_width.l,_area_height.l)
    
    EndIf
  

EndProcedure


Procedure  WC_AREA_SET_TO_ICON()
  
  ClearScreen(RGB(0,0,0))
   ResetList(map_object())

  ;----------- sort the tiles per layer
  
  SortStructuredList(map_object(),#PB_Sort_Ascending  ,OffsetOf(map_objects\_layer),TypeOf(map_objects\_layer))
  
  While NextElement(map_object())
    
    SpriteQuality(#PB_Sprite_BilinearFiltering)
    SpriteBlendingMode(#PB_Sprite_BlendSourceAlpha, #PB_Sprite_BlendInvertSourceAlpha) ;default
    
    If map_object()\_alpha_blend>0
      SpriteBlendingMode(#PB_Sprite_BlendSourceAlpha, map_object()\_alpha_blend)
    EndIf
      
          DisplayTransparentSprite(map_object()\_gfx_id,map_object()\_x-wc_area_offset_x.f,map_object()\_y-wc_area_offset_y.f,map_object()\_transparency)
      
      Wend
      FlipBuffers()
      
EndProcedure



Procedure WC_RESTART_MAP_FOR_AREA()
  ;this routine sets all map data to "zero state" , map begins at (0,0) 
  ;default for area offsets:
  wc_area_offset_x.f=65000  ;default value
  wc_area_offset_y.f=65000
  ;--------------------------------------------------------------
  
  If ListSize(map_object())>0
    ResetList(map_object())
    While NextElement(map_object())
       ;go for the left upper corner of the area
       ;we set the origin cooardinates  to (0,0) to grab the  icon(png gfx for map creator use)
      
      If wc_area_offset_x.f>map_object()\_x
        wc_area_offset_x.f=map_object()\_x
      EndIf
      
      If wc_area_offset_y.f>map_object()\_y
      wc_area_offset_y.f=map_object()\_y  
    EndIf
                     Wend
        EndIf
     
EndProcedure


Procedure WC_GET_MAP_GFX()
;this routine is used for gfx load only, it is part of WC_LOAD_MAP_PARSER()  
  
  Define _ok.l=0
  Define _key.s=""
  Define _val.l=0
  
  ResetList(map_object())
   
  While NextElement(map_object())
    
    _ok.l=ReadFile(#PB_Any,  v_resource_path+map_object()\_ai_path)
  
    If IsFile(_ok.l)
      
       map_object()\_DO_NOT_SHOW=#False
      
      ;now parse for the gfx:
            
      While Not Eof(_ok.l)
               
        _key.s=ReadString(_ok.l)
        
                Select _key.s
                
      Case "object_source#"
          
                    _key.s=ReadString(_ok.l)
          
          map_object()\_gfx_id=LoadSprite(#PB_Any,v_resource_path+GetFilePart(_key.s), #PB_Sprite_AlphaBlending ); we have to set a relative path for the file, because we use a resourcefile for source so we can use it.
          
          If IsSprite(map_object()\_gfx_id)
      
          Else
            
           map_object()\_DO_NOT_SAVE_THIS_OBJECT=#True
            
            If wc_ignore_map_error.b=#False
              WC_ERROR(#WC_ERROR_CAN_NOT_CREATE_OBJECT,"CAN ONT LOAD GFX, "+v_resource_path+GetFilePart(_key.s)) 

          EndIf
         
           
         EndIf
         
           
      
           
         
       Case "object_full_screen.b"
         
         _val.l=Val(ReadString(_ok.l))
         
         If _val.l=1
           
           map_object()\_full_screen=#True
           
           ZoomSprite(map_object()\_gfx_id,wc_engine_screen_width,wc_engine_screen_height)
           
         Else
           
           map_object()\_full_screen=#False
           
           
         EndIf
         
       Case "object_transparency.l"
         map_object()\_transparency=255-Val(ReadString(_ok.l))
       
       Case "object_auto_layer.b"
         map_object()\_object_auto_layer=Val(ReadString(_ok.l))
       
       Case "DO_NOT_SAVE_THIS_OBJECT" ; ::::: INTERNAL USE ONLY ::::::::: if #true, object will no longer saved as  part of the map, use it if you want to remove a huge ammont of obsolete gfx from the map (to remove object:set value, at the object data in the  AI42Creator)
         map_object()\_DO_NOT_SAVE_THIS_OBJECT=Val(ReadString(_ok.l))
         
         
       Case "object_alpha_blend.l"
         E_DEFINE_BLENDING_MODE_MAP(ReadString(_ok.l))
         
       Case "object_is_procedural_base.b"
         map_object()\object_is_procedural_base=Val(ReadString(_ok.l))
         If map_object()\object_is_procedural_base>0
         map_object()\object_procedural_done=#False  
         EndIf
         
       Case "object_procedural_source_name.s"
         map_object()\object_procedural_source_name=ReadString(_ok.l)
         
       Case "object_procedural_max_objects.l"
         map_object()\object_procedural_max_objects=Val(ReadString(_ok.l))
         
       Case "object_procedural_x_offset.f"
         map_object()\object_procedural_x_offset=ValF(ReadString(_ok.l))
         Case "object_procedural_y_offset.f"
           map_object()\object_procedural_y_offset=ValF(ReadString(_ok.l))
           
         Case "object_procedural_seed.l"
           map_object()\object_procedural_seed=Val(ReadString(_ok.l)) 
           
         Case "object_use_random_angle.f"
           map_object()\object_use_random_angle=ValF(ReadString(_ok.l))
           RotateSprite(map_object()\_gfx_id,Random(map_object()\object_use_random_angle),#PB_Absolute)
           
         Case "object_use_shadow.b"
           map_object()\object_use_shadow=Val(ReadString(_ok.l))
           
         Case "object_shadow_intense.l"
           map_object()\object_shadow_intense=Val(ReadString(_ok.l))
           
           
           
              Case "object_add_to_quest.b"
           map_object()\object_add_to_quest=Val(ReadString(_ok.l))
           
           If map_object()\object_add_to_quest<>0
             wc_quest_book.l+1  
             EndIf
           
           
       EndSelect
           
      Wend

      
      
     
      CloseFile(_ok.l)
  
    Else
      
       map_object()\_DO_NOT_SAVE_THIS_OBJECT=#True  ;if object or AI42 file is not valid, exclude it from save to the map
      
      If wc_ignore_map_error.b=#False
        WC_ERROR(#WC_ERROR_CAN_NOT_CREATE_OBJECT,"CAN ONT LOAD GFX, "+v_resource_path+map_object()\_ai_path)
      EndIf
      
     
    EndIf
    
  
  Wend
  
EndProcedure

Procedure WC_WRITE_AREA_AI42_DATA(_file_id.l,_full_path.s,_gfx_full_path.s)

  WriteStringN(_file_id.l,"object_name#")
  WriteStringN(_file_id.l,"NULL")
  WriteStringN(_file_id.l,"object_source#")
  WriteStringN(_file_id.l,_gfx_full_path.s)
  WriteStringN(_file_id.l,"object_file#")
  WriteStringN(_file_id.l,GetFilePart(_full_path.s,#PB_FileSystem_NoExtension))
  WriteStringN(_file_id.l,"object_type")
  WriteStringN(_file_id.l,"png")
  WriteStringN(_file_id.l,"object_is_area.b")   ;special for areas, not used for default objects
  WriteStringN(_file_id.l,"1")                  ;default area identification
  WriteStringN(_file_id.l,"object_area_ai42_path.s")
  WriteStringN(_file_id.l,GetFilePart(_full_path.s))
  WriteStringN(_file_id.l,"object_area_path.s")
  WriteStringN(_file_id.l,GetFilePart(_full_path.s,#PB_FileSystem_NoExtension)+".area")
  WriteStringN(_file_id.l,"object_intensity.b")
  WriteStringN(_file_id.l,"1")  ;heavy waight :) 

   
EndProcedure



Procedure WC_SET_AREA_AI42(_full_path.s,_gfx_full_path.s)
  ;here we create the area42 code for the area objects:
;   object_name#
; NULL
; object_source#
; C:\Users\Benutzer1\Desktop\DEVELOPE\ADVENTURE\PROJECT17\data\WORLD\DATA\8.png
; object_file#
; 8
; object_type#
; png
  
  Define _ok.l=0
  
  _ok.l=CreateFile(#PB_Any,_full_path.s)
  
  If IsFile(_ok.l)
        WC_WRITE_AREA_AI42_DATA(_ok.l,_full_path.s,_gfx_full_path.s)
        CloseFile(_ok.l)
    
  EndIf
  
EndProcedure

Procedure  WC_GET_MAP_VIEW_SIZE(_file_id.l,_key.s)
  ;here we read the map viepoints (w x h)
  
  Select _key.s
    Case "WORLD_VIEW_W"
      wc_engine_screen_width.l=Val(ReadString(_file_id.l))
           
    Case "WORLD_VIEW_H"
            wc_engine_screen_height.l=Val(ReadString(_file_id.l))
      
  EndSelect
  
  
EndProcedure


Procedure WC_LOAD_MAP_PARSER(_file_id.l,_file.s)
  
  
  Define _x.l=0
  Define _y.l=0
  Define _object_path.s=""
  Define _layer.b=0
  Define _key.s=""
  
  ;for the 
  
  Repeat  
   
    _key.s=ReadString(_file_id.l)
     WC_GET_MAP_VIEW_SIZE(_file_id.l,_key.s)
      
  Until  Eof(_file_id.l) Or _key.s="WORLD_START:"
  
  ;we got it? 
    
      While Not Eof(_file_id.l)
        
       SetWindowTitle(v_window_parent_id,"************************** LOADING MAP ************************** Please Wait :) ******************************")
   
        _key.s=ReadString(_file_id.l)

        
        Select _key.s
            
            
          Case "WORLD_GLOBAL_SOUND"
            
            wc_full_sound_path.s=ReadString(_file_id.l)
            wc_sound_id.i=LoadSound(#PB_Any,wc_full_sound_path.s)
            
            If IsSound(wc_sound_id.i)
              wc_sound_ok=#True
            Else
              wc_sound_ok=#False
            EndIf
            
            
            
          Case "USE_AUTO_LAYER"
            
            If ReadString(_file_id.l)="YES"
              
              wc_use_auto_layer.b=#True
              wc_auto_object.s="*************    AUTO LAYER   ***********"
            
            Else
              wc_use_auto_layer.b=#False
              wc_auto_object.s="*************NO   AUTO LAYER ***********"
             
              
            EndIf
            
            
            
          Case "OFFSETX:"
            wc_x_offset.l=Val(ReadString(_file_id.l))
            
          Case "OFFSETY:"
             wc_y_offset.l=Val(ReadString(_file_id.l))
            
          Case "NEXTELEMENT:"
            
            
            If AddElement(map_object())
              
              
              _key.s=ReadString(_file_id.l)
              
              
              If _key.s="OBJECTSOURCE:"
                  
                  map_object()\_ai_path=ReadString(_file_id.l)
                  
              EndIf
           
              _key.s=ReadString(_file_id.l)
              
             If  _key.s="OBJECT_X:"
              map_object()\_x=Val(ReadString(_file_id.l))
             EndIf
                       
               
              _key.s=ReadString(_file_id.l)
              
             If  _key.s="OBJECT_Y:"
               map_object()\_y=Val(ReadString(_file_id.l))
             EndIf
             
             
             _key.s=ReadString(_file_id.l)
             
             If _key.s="OBJECTLAYER:"
               
               map_object()\_layer=Val(ReadString(_file_id.l))
               
             EndIf
    
              
            Else
              
              WC_ERROR(#WC_ERROR_CAN_NOT_ADD_OBJECT,"CAN NOT ADD ELEMENT, CONTINUE?")
              
            EndIf
        
    
        EndSelect
  
      Wend
      
      
       WC_GET_MAP_GFX()

EndProcedure
Procedure WC_LOAD_AREA_PARSER(_file_id.l)

  Define _key.s=""
  Define _dummy.s=""
  
  ;for the 

  Repeat  
    
    _key.s=ReadString(_file_id.l)
    
  Until  Eof(_file_id.l) Or _key.s="AREA_START:"
  
  ;we got it? 
    
      While Not Eof(_file_id.l)

       SetWindowTitle(v_window_parent_id,"************************** LOADING AREA        ************************** Please Wait :) ******************************")
   
        _key.s=ReadString(_file_id.l)
         
        Select _key.s
                    
          Case "OFFSETX:"
        ;nope
        
          Case "OFFSETY:"
   ;nope 

            
          Case "NEXTELEMENT:"

            If AddElement(map_object())

              _key.s=ReadString(_file_id.l)
                           
              If _key.s="OBJECTSOURCE:"
                                    map_object()\_ai_path=ReadString(_file_id.l)
              EndIf
           
              _key.s=ReadString(_file_id.l)
              
             If  _key.s="OBJECT_X:"
               map_object()\_x=Val(ReadString(_file_id.l))+WindowMouseX(v_window_parent_id)-wc_x_offset.l-SpriteWidth(wc_work_gfx\_gfx_id)/2
            EndIf
             
              _key.s=ReadString(_file_id.l)
              
             If  _key.s="OBJECT_Y:"
               map_object()\_y=Val(ReadString(_file_id.l))+WindowMouseY(v_window_parent_id)-wc_y_offset.l-SpriteHeight(wc_work_gfx\_gfx_id)/2
             EndIf
                          
             _key.s=ReadString(_file_id.l)
             
             If _key.s="OBJECTLAYER:"
                        map_object()\_layer=Val(ReadString(_file_id.l))
                EndIf
    
                       Else
              
              WC_ERROR(#WC_ERROR_CAN_NOT_ADD_OBJECT,"CAN NOT ADD ELEMENT, CONTINUE?")
              
            EndIf
            
        EndSelect
  
      Wend
                   WC_GET_MAP_GFX()
EndProcedure







Procedure  WC_GET_MOUSE_DESKTOP()
  ;here we get the mouse position all over the system
  ;so we can handle the mouse pointer and window focus all over the system
  
  v_mouse_desktop_x.l=DesktopMouseX()
  v_mouse_desktop_y=DesktopMouseY()
  
  
  If v_mouse_desktop_x.l<v_window_w.l
    
    If v_mouse_desktop_x.l>v_window_main_x.l
    
    
  EndIf
  
  If v_mouse_desktop_y.l<v_window_h.l
    
    If v_mouse_desktop_y>v_window_main_y.l
      
      SetActiveWindow(v_window_parent_id)
     
    EndIf
    
    
  EndIf
  
  
EndIf

EndProcedure  


Procedure  WC_SOUND_PLAY(_void.l)
  
  If wc_sound_ok=#True
    
    Select _void.l  
        
      Case #WC_SOUND_PLAY
        StopSound(wc_sound_id.i)
        PlaySound(wc_sound_id.i)
        
      Case #WC_SOUND_STOP
        StopSound(wc_sound_id.i)
        
      Case #WC_REMOVE_SOUND_FROM_MAP
        
        If IsSound(wc_sound_id.i)
              StopSound(wc_sound_id.i)
          FreeSound(wc_sound_id.i)
          wc_sound_ok.b=#False
        EndIf
        
        
    EndSelect
    
  EndIf
  
  
EndProcedure


  
  Procedure  WC_LOAD_SOUND()
    Define _ok.l=0
    
    wc_full_sound_path.s=OpenFileRequester("ADD GLOBAL SOUND TO MAP:           ",wc_full_sound_path.s,"SOUND: (*snd) |*.ogg",0)
    
    wc_sound_id.i=LoadSound(#PB_Any,wc_full_sound_path.s)
    
    If IsSound(wc_sound_id.i)
       wc_sound_ok.b=#True
      _ok.l=MessageRequester("                                   SOUND                                  ","  VALID  OGG SOUND FOUND    ",#PB_MessageRequester_Ok)
      
    Else
       wc_sound_ok.b=#False
      _ok.l=MessageRequester("                                   SOUND                                  ","           **************  NOT FOUND   ************  ",#PB_MessageRequester_Ok)
      
    EndIf
    
    
    EndProcedure


Procedure WC_LOAD_WORLD(_mode.l)

  Define _ok.l=0
  
  wc_quest_book.l=0
  
  If _mode.l<>#USE_CACHE
    wc_global_load_save_path.s=OpenFileRequester("LOAD MAP: ",wc_global_load_save_path.s,"WORLDMAP FILES|*.worldmap",0)
   
      Else
   wc_global_load_save_path.s=v_cache_dir+Str(v_cache_id)+".cache"
  EndIf
      
  _ok.l=ReadFile(#PB_Any, wc_global_load_save_path.s)
  If IsFile(_ok.l)
    
    If IsSound(wc_sound_id.i)
      StopSound(wc_sound_id.i)
          FreeSound(wc_sound_id.i)
          wc_sound_ok.b=#False
        EndIf
    ;now we need the garbage collector, we reset all to zero to load the new data
    WC_GARBAGE_COLLECTOR()
    WC_LOAD_MAP_PARSER(_ok.l, wc_global_load_save_path.s)
    
    CloseFile(_ok.l)
  
        
    
    ;sort object using the layer information stored in the map -----> from lowest to highest layer (-xxxx..........+xxxxx)
    SortStructuredList(map_object(),#PB_Sort_Ascending  ,OffsetOf(map_objects\_layer),TypeOf(map_objects\_layer))
    
  EndIf
  
EndProcedure

Procedure WC_ADD_AREA(_mode.l)
  
  
  ;here we add the area (for debugging, we just place it (0,0)) we DO NOT USE garbagecollector, we add objects to list....
  Define _ok.l=0
  Define _ok_dummy.l=0
  
  If _mode.l=#WC_SILENT
    
    _ok.l=ReadFile(#PB_Any,  v_resource_path+wc_work_gfx\object_area_path)
  ;  _ok_dummy.l=MessageRequester("DUMMY",v_resource_path+wc_work_gfx\object_area_path,#PB_MessageRequester_Ok  )  ;debugging
    
    
    If IsFile(_ok.l)
      wc_area_place_x.f= WindowMouseX(v_window_parent_id)+wc_x_offset.l
     wc_area_place_y.f=WindowMouseY(v_window_parent_id)+wc_y_offset.l
      WC_LOAD_AREA_PARSER(_ok.l)
      SortStructuredList(map_object(),#PB_Sort_Ascending  ,OffsetOf(map_objects\_layer),TypeOf(map_objects\_layer))
      CloseFile(_ok.l)
      
    EndIf
    
  EndIf
  
  If _mode.l<>#WC_SILENT
    wc_global_load_save_path.s=OpenFileRequester("LOAD AREA: ",wc_global_load_save_path.s,"AREA|*.area",0)
    _ok.l=ReadFile(#PB_Any, wc_global_load_save_path.s)
    
    If IsFile(_ok.l)
      WC_LOAD_AREA_PARSER(_ok.l)
      CloseFile(_ok.l)
      SortStructuredList(map_object(),#PB_Sort_Ascending  ,OffsetOf(map_objects\_layer),TypeOf(map_objects\_layer))
    EndIf
    
  EndIf
  
EndProcedure

Procedure WC_LOAD_AREA()
  
  
  ;here we load area for  building (we use the garbage collector)
  Define _ok.l=0
  
  wc_global_load_save_path.s=OpenFileRequester("LOAD AREA: ",wc_global_load_save_path.s,"AREA|*.area|PNG|*.png",0)
  _ok.l=ReadFile(#PB_Any, wc_global_load_save_path.s)
  If IsFile(_ok.l)
    WC_GARBAGE_COLLECTOR()
    WC_LOAD_AREA_PARSER(_ok.l)
    CloseFile(_ok.l)
    SortStructuredList(map_object(),#PB_Sort_Ascending  ,OffsetOf(map_objects\_layer),TypeOf(map_objects\_layer))
  EndIf
  
EndProcedure

Procedure WC_SAVE_AREA()
  ;here we save our areas so we can use them as full  objects for fast building
  ;format is the same as mapcreator format, area files will be added to list to the map on mouseposition
  Define  _ok.l=0
  Define _save_path.s=""
  Define _file_part.s=""
  Define _path_part.s=""
  
  
  wc_global_load_save_path.s=SaveFileRequester("SAVE MAP: ", wc_global_load_save_path.s,"AREA|*.area",0)
  ;   _save_path.s=GetFilePart(wc_global_load_save_path.s,#PB_FileSystem_NoExtension)    ;make shure that we use "ONE" extension not multiple....
  ;  _save_path.s=wc_area_container_path.s+wc_global_load_save_path.s
  ;reset the offset so we can grab the immage as icon for our area
  ;---------------------------------------------------------------------------------------------
  ;
  ;            get part and name of the file / split it for correct use
  ;
  _save_path.s= wc_global_load_save_path.s
  _file_part.s=GetFilePart(_save_path.s,#PB_FileSystem_NoExtension)
  _path_part.s=GetPathPart(wc_global_load_save_path.s)
  _save_path.s=_path_part.s+_file_part.s+".area"
  ;--------------------------------------------------------------------------------------------
  ;reset the view:
  ;------------------------------------------------------------------
  _ok.l=CreateFile(#PB_Any, _save_path.s)
  
  
  If  IsFile(_ok.l)
    
    WC_RESTART_MAP_FOR_AREA()
    WC_AREA_SET_TO_ICON()
    WC_GET_AREA_ICON()
    
    SortStructuredList(map_object(),#PB_Sort_Ascending  ,OffsetOf(map_objects\_layer),TypeOf(map_objects\_layer))
    
    ResetList(map_object())
    
    WriteStringN(_ok.l,"*********************************************************************************************************")
    WriteStringN(_ok.l,"WORLD MAP CREATOR FILE : GENERATED BY -WORLDMAP CREATOR- TOOL ")
    WriteStringN(_ok.l,"DEUTSCHMANN WALTER (DEUTSCHMANN DEVELOPEMENT) ALL RIGHTS RESERVED")
    WriteStringN(_ok.l,"DO NOT CHANGE CONTENTS OF FILE, THIS MAY HARM SYSTEM AND APP STABILITY")
    WriteStringN(_ok.l,"MAP OBJECTS: ")
    WriteStringN(_ok.l,Str(ListSize(map_object()) ))
    WriteStringN(_ok.l,"*********************************************************************************************************")
    WriteStringN(_ok.l,"AREA_START:"); keyword for io system to read map file startign with next position in skript file
    WriteStringN(_ok.l,"USE_AUTO_LAYER") ;here we store the autolayer function
    WriteStringN(_ok.l,wc_auto_layer.s)
    WriteStringN(_ok.l,"OFFSETX:")
    WriteStringN(_ok.l,Str(0))
    WriteStringN(_ok.l,"OFFSETY:")
    WriteStringN(_ok.l,Str(0))
    
    While NextElement(map_object()) 
      
      If map_object()\object_is_procedural_base=0 
   
        
        If map_object()\_DO_NOT_SAVE_THIS_OBJECT<>1  ;here we sort out the global object garbage, we do not save object we will never use/need
          
          WriteStringN(_ok.l,"NEXTELEMENT:")
          WriteStringN(_ok.l,"OBJECTSOURCE:")
          WriteStringN(_ok.l,map_object()\_ai_path)
          WriteStringN(_ok.l,"OBJECT_X:")
          WriteStringN(_ok.l,Str(map_object()\_x-wc_area_offset_x))
          WriteStringN(_ok.l,"OBJECT_Y:")
          WriteStringN(_ok.l,Str(map_object()\_y-wc_area_offset_y))
          WriteStringN(_ok.l,"OBJECTLAYER:")
          WriteStringN(_ok.l,Str(map_object()\_layer))
          WriteStringN(_ok.l,"OBJECT_W:")
          WriteStringN(_ok.l,Str(SpriteWidth(map_object()\_gfx_id)))
          WriteString(_ok.l,"OBJECT_H:")
           WriteStringN(_ok.l,Str(SpriteHeight(map_object()\_gfx_id)))
          
        EndIf
        
        EndIf
      
    Wend
    
    CloseFile(_ok.l)
    
    
    If SaveSprite(wc_area_file_icon.i,_path_part.s+_file_part.s+".png",#PB_ImagePlugin_PNG)
      ;here we go for the area-ai42:
     EndIf
     WC_SET_AREA_AI42(_path_part.s+_file_part.s+".ai42",_path_part.s+_file_part.s+".png")

    
    _ok.l=MessageRequester("WORLDCREATOR:    AREA:     ", wc_global_load_save_path.s+Chr(13)+" AREA CREATED",#PB_MessageRequester_Info)
    
  EndIf
  
EndProcedure


Procedure WC_SAVE_WORLD(_mode.l)
  ;now we try to save the mess:
  Define  _ok.l=0
  Define _save_path.s=""
  
   wc_quest_book.l=0  ;for start we have no chapters
  
  If _mode.l<>#USE_CACHE
    wc_global_load_save_path.s=SaveFileRequester("SAVE MAP: ", wc_global_load_save_path.s,"*.worldmap",0)
   _save_path.s=wc_global_load_save_path.s
   Else
   _save_path.s=v_cache_dir+Str(v_cache_id)+".cache"
  EndIf
  
  _ok.l=CreateFile(#PB_Any, _save_path.s)
  
  If  IsFile(_ok.l)
     
    SortStructuredList(map_object(),#PB_Sort_Ascending  ,OffsetOf(map_objects\_layer),TypeOf(map_objects\_layer))
     ResetList(map_object())
    
    WriteStringN(_ok.l,"*********************************************************************************************************")
    WriteStringN(_ok.l,"WORLD MAP CREATOR FILE : GENERATED BY -WORLDMAP CREATOR- TOOL ")
    WriteStringN(_ok.l,"DEUTSCHMANN WALTER (DEUTSCHMANN DEVELOPEMENT) ALL RIGHTS RESERVED")
    WriteStringN(_ok.l,"DO NOT CHANGE CONTENTS OF FILE, THIS MAY HARM SYSTEM AND APP STABILITY")
    WriteStringN(_ok.l,"MAP OBJECTS: ")
    WriteStringN(_ok.l,Str(ListSize(map_object()) ))
    WriteStringN(_ok.l,"*********************************************************************************************************")
    WriteStringN(_ok.l,"WORLD_VIEW_W")
    WriteStringN(_ok.l,Str(wc_engine_screen_width.l))
    WriteStringN(_ok.l,"WORLD_VIEW_H")
    WriteStringN(_ok.l,Str(wc_engine_screen_height.l))
    WriteStringN(_ok.l,"WORLD_START:"); keyword for io system to read map file startign with next position in skript file
    WriteStringN(_ok.l,"WORLD_GLOBAL_SOUND")
    WriteStringN(_ok.l,wc_full_sound_path.s) ;for mapcreator we use full path of sound
    WriteStringN(_ok.l,"USE_AUTO_LAYER")     ;here we store the autolayer function
    WriteStringN(_ok.l,wc_auto_layer.s)
    WriteStringN(_ok.l,"OFFSETX:")
    WriteStringN(_ok.l,Str(wc_x_offset.l))
    WriteStringN(_ok.l,"OFFSETY:")
    WriteStringN(_ok.l,Str(wc_y_offset.l))
     

    
    While NextElement(map_object()) 
      
 
   
      If _mode.l=#USE_CACHE
      
      If  map_object()\_DO_NOT_SHOW=#False  ;undo/redo
             
          If map_object()\_DO_NOT_SAVE_THIS_OBJECT<>1  ;here we sort out the global object garbage, we do not save object we will never use/need
            
            WriteStringN(_ok.l,"NEXTELEMENT:")
            WriteStringN(_ok.l,"OBJECTSOURCE:")
            WriteStringN(_ok.l,map_object()\_ai_path)
            WriteStringN(_ok.l,"OBJECT_X:")
            WriteStringN(_ok.l,Str(map_object()\_x))
            WriteStringN(_ok.l,"OBJECT_Y:")
            WriteStringN(_ok.l,Str(map_object()\_y))
            WriteStringN(_ok.l,"OBJECTLAYER:")
            WriteStringN(_ok.l,Str(map_object()\_layer))
            WriteStringN(_ok.l,"OBJECT_W:")
    WriteStringN(_ok.l,Str(SpriteWidth(map_object()\_gfx_id)))
    WriteStringN(_ok.l,"OBJECT_H:")
    WriteStringN(_ok.l,Str(SpriteHeight(map_object()\_gfx_id)))
     
        If    map_object()\object_add_to_quest<>0
      wc_quest_book.l+1
   EndIf
      
  
    
          EndIf
          
    
        
        
      EndIf  ;undo / redo
      
    EndIf ;use cache ?
    
     If _mode.l<>#USE_CACHE
      
      If  map_object()\_DO_NOT_SHOW=#False  ;undo/redo
             
        If map_object()\object_is_procedural_base=0 
          
          If map_object()\_DO_NOT_SAVE_THIS_OBJECT<>1  ;here we sort out the global object garbage, we do not save object we will never use/need
            
            WriteStringN(_ok.l,"NEXTELEMENT:")
            WriteStringN(_ok.l,"OBJECTSOURCE:")
            WriteStringN(_ok.l,map_object()\_ai_path)
            WriteStringN(_ok.l,"OBJECT_X:")
            WriteStringN(_ok.l,Str(map_object()\_x))
            WriteStringN(_ok.l,"OBJECT_Y:")
            WriteStringN(_ok.l,Str(map_object()\_y))
            WriteStringN(_ok.l,"OBJECTLAYER:")
            WriteStringN(_ok.l,Str(map_object()\_layer))
                    WriteStringN(_ok.l,"OBJECT_W:")
    WriteStringN(_ok.l,Str(SpriteWidth(map_object()\_gfx_id)))
    WriteStringN(_ok.l,"OBJECT_H:")
    WriteStringN(_ok.l,Str(SpriteHeight(map_object()\_gfx_id)))
     
  If    map_object()\object_add_to_quest<>0
      wc_quest_book.l+1
   EndIf
      
    
          EndIf
          
        EndIf
        
        
      EndIf  ;undo / redo
      
    EndIf ;not use cache 
   
    Wend
    
    WriteStringN(_ok.l,"QUESTBOOK_CHAPTERS")
    WriteStringN(_ok.l,Str(wc_quest_book.l))
    
    CloseFile(_ok.l)
    
    If _mode.l=#USE_CACHE
    v_cache_id.l+1  
    EndIf
    v_cache_last_id.l=v_cache_id.l
    
    If _mode.l<>#USE_CACHE
    _ok.l=MessageRequester("WORLDCREATOR INFO:", wc_global_load_save_path.s+Chr(13)+" CREATED",#PB_MessageRequester_Info)
  EndIf
  
  EndIf
   
EndProcedure


Procedure WC_MAP_OBJECT_UNDO()
  
  
  If v_cache_id.l>0
    v_cache_id.l-1
    WC_LOAD_WORLD(#USE_CACHE)
  EndIf
  
EndProcedure




Procedure WC_MAP_OBJECT_REDO()
 
  If v_cache_id.l<v_cache_last_id.l
    v_cache_id.l+1 
    WC_LOAD_WORLD(#USE_CACHE)
  EndIf
  
  

  EndProcedure


Procedure WC_MENU_EVENT()
  Define _msg.l=0
  
  Select EventMenu()
      
      Case #WC_MENU_QUIT
        
        _msg.l=MessageRequester("QUIT WORLDCREATOR?","QUIT?",#PB_MessageRequester_YesNo)
      
        If _msg.l=#PB_MessageRequester_Yes
          
         WC_CLEAN_CACHE( v_clean_cache_on_exit.b)
         
       End
      EndIf
      
      
      
    Case #WC_MENU_LOAD_MAP
      WC_LOAD_WORLD(0)
      
    Case #WC_MENU_SAVE_MAP
      WC_SAVE_WORLD(0)
      
    Case #WC_MENU_SET_RESURCE
      WC_SET_RESOURCE()
      
    Case #WC_MENU_RESTART_SYSTEM
        ;   WC_RESTART_MAP()
    Case #WC_MENU_UNDO
      WC_MAP_OBJECT_UNDO()
      
      
    Case #WC_MENU_REDO
      
     WC_MAP_OBJECT_REDO()
      
    Case #WC_MENU_NEW

      WC_ERROR(#WC_ERROR_NOT_SAVED_CONTENT_WILL_BE_LOST," NOT SAVED CONTENT WILL BE LOST?")
      
    Case #WC_LAYER_M1
      wc_layer.b=-1
       Case #WC_LAYER_M2
         wc_layer.b=-2
          Case #WC_LAYER_M3
            wc_layer.b=-3
             Case #WC_LAYER_M4
               wc_layer.b=-4
                Case #WC_LAYER_M5
                  wc_layer.b=-5
                  
    Case #WC_LAYER_0
      wc_layer.b=0
       Case #WC_LAYER_1
         wc_layer.b=1
          Case #WC_LAYER_2
            wc_layer.b=2
             Case #WC_LAYER_3
               wc_layer.b=3
                Case #WC_LAYER_4
                  wc_layer.b=4
                   Case #WC_LAYER_5
                     wc_layer.b=5
                      Case #WC_LAYER_6
                        wc_layer.b=6
                         Case #WC_LAYER_7
                           wc_layer.b=7
                            Case #WC_LAYER_8
                              wc_layer.b=8
                               Case #WC_LAYER_9
                                 wc_layer.b=9
                                  Case #WC_LAYER_10
                                      wc_layer.b=10
                        
                      Case #WC_SHOW_ACTUAL_LAYER
                        wc_layer_show.b=wc_layer.b
                        
                      Case #WC_SHOW_ALL_LAYER
                        wc_layer_show.b=-127
                        
                      Case #WC_MENU_SHOW_LAYER_ID
                        wc_show_layer_id.b=#True
                        
                      Case #WC_MENU_DO_NOT_SHOW_LAYER_ID
                        wc_show_layer_id.b=#False
                        
                      Case #WC_MENU_SHOW_ENGINE_AREA
                        
                        If wc_engine_screen_area_show.b=#True
                          wc_engine_screen_area_show.b=#False
                        Else
                          wc_engine_screen_area_show.b=#True
                        EndIf
                        
                        
                      Case #WC_MENU_MOVE_MAP_OBJECT_SIZE
                        wc_map_move_per_pixel=#False
                        
                        
                      Case  #WC_MENU_MOVE_MAP_PER_PIXEL
                        wc_map_move_per_pixel=#True
                        
                      Case #WC_USE_RASTER_NO
                        wc_use_object_based_raster.b=0
                        
                      Case #WC_USE_RASTER_YES
                        wc_use_object_based_raster.b=1
                        
                      Case #WC_USE_AUTO_LAYER
                        wc_use_auto_layer.b=#True
                        wc_auto_object.s="******AUTO LAYER*****"
                        wc_auto_layer.s="YES"
                        
                      Case #WC_DO_NOT_USE_AUTO_LAYER
                        wc_use_auto_layer.b=#False
                        wc_auto_object.s="NO AUTO LAYER"
                        wc_auto_layer.s="NO"
                        
                      Case #WC_MENU_INFO
                        WC_INFO()
                        
                      Case #WC_MENU_START_PROCEDURAL
                        WC_START_PROCEDURAL()
                        
                      Case  #WC_ADD_SOUND_TO_MAP
                        WC_LOAD_SOUND()
                        
                      Case #WC_SOUND_PLAY
                        WC_SOUND_PLAY( #WC_SOUND_PLAY)
                        
                      Case #WC_SOUND_STOP
                        WC_SOUND_PLAY(#WC_SOUND_STOP)
                        
                      Case #WC_REMOVE_SOUND_FROM_MAP
                        WC_SOUND_PLAY(#WC_REMOVE_SOUND_FROM_MAP)
                        
                      Case #WC_AREA_SAVE_AS
                        WC_SAVE_AREA()
                        
                      Case #WC_AREA_LOAD
                        WC_LOAD_AREA()
                        
                      Case #WC_AREA_ADD
                        WC_ADD_AREA(0)
                        
                      Case #WC_FLIP_MAP_H
                        WC_FLIP_MAP_H()
                        
                      Case #WC_MENU_ADD_MAP_TEMPLATE
                        WC_LOAD_TEMPLATE()
                        
                      Case #WC_TEMPLATE_TRANSPARENCY_ADD
                        
                      WC_TEMPLATE_TRANSPARENCY_ADD()
                                               
                      Case #WC_TEMPLATE_TRANSPARENCY_REMOVE
                        WC_TEMPLATE_TRANSPARENCY_REMOVE()
                        
                      Case #WC_HIDE_TEMPLATE
                        WC_TEMPLATE_HIDE()
                        
                      Case #WC_VIEW_800_450
                           wc_engine_screen_width.l=800
                        wc_engine_screen_height.l=450
                        
                      Case #WC_VIEW_1000_564  ;default
                       wc_engine_screen_width.l=1000
                        wc_engine_screen_height.l=564
                        
                      Case #WC_VIEW_1280_720
                        wc_engine_screen_width.l=1280
                        wc_engine_screen_height.l=720
                        
                      Case #WC_VIEW_1440_1080
                       wc_engine_screen_width.l=1440
                        wc_engine_screen_height.l=1080  
                        
                      Case #WC_VIEW_1600_900
                      wc_engine_screen_width.l=1600
                        wc_engine_screen_height.l=900
                        
                      Case #WC_VIEW_1920_1080
                          wc_engine_screen_width.l=1920
                        wc_engine_screen_height.l=1080
                        
                        
                        
  EndSelect
  
 
EndProcedure





Procedure WC_MENU_WINDOW_EVENT(_event.l)
  ;here we pick the gfxobjects for the worldmaker
  
  Select _event.l
      
    Case    #PB_Event_Gadget
      
      If SelectElement(wc_menu_object(),EventGadget()-#LAST_UI_GADGET)
        wc_work_gfx\_gfx_path=wc_menu_object()\_gfx_path
        wc_work_gfx\_ai_path=wc_menu_object()\_ai_path
        If IsSprite(wc_work_gfx\_gfx_id)
        FreeSprite(wc_work_gfx\_gfx_id)  
        EndIf
        
        wc_work_gfx\_gfx_id=LoadSprite(#PB_Any,wc_work_gfx\_gfx_path,#PB_Sprite_AlphaBlending)
        wc_work_with.l=SpriteWidth(wc_work_gfx\_gfx_id)
        wc_work_height.l=SpriteHeight(wc_work_gfx\_gfx_id)
        wc_work_gfx\_full_screen=wc_menu_object()\_full_screen
        wc_work_gfx\_raster_x=wc_work_with.l
        wc_work_gfx\_raster_y=wc_work_height.l
        wc_work_gfx\_transparency=255-wc_menu_object()\_transparency
        wc_work_gfx\_object_auto_layer=wc_menu_object()\_object_auto_layer
        wc_work_gfx\_alpha_blend=wc_menu_object()\_alpha_blend
        wc_work_gfx\object_is_procedural_base=wc_menu_object()\object_is_procedural_base
        wc_work_gfx\object_procedural_seed=wc_menu_object()\object_procedural_seed
        wc_work_gfx\object_procedural_source_name=wc_menu_object()\object_procedural_source_name
        wc_work_gfx\object_procedural_x_offset=wc_menu_object()\object_procedural_x_offset
        wc_work_gfx\object_procedural_y_offset=wc_menu_object()\object_procedural_y_offset
        wc_work_gfx\object_procedural_max_objects=wc_menu_object()\object_procedural_max_objects
        wc_work_gfx\object_procedural_done=wc_menu_object()\object_procedural_done
        wc_work_gfx\object_use_random_angle=wc_menu_object()\object_use_random_angle
        wc_work_gfx\object_use_shadow=wc_menu_object()\object_use_shadow
        wc_work_gfx\object_shadow_intense=wc_menu_object()\object_shadow_intense
        wc_work_gfx\object_is_area=wc_menu_object()\object_is_area
        wc_work_gfx\object_area_42_path=wc_menu_object()\object_area_42_path
        wc_work_gfx\object_area_path=wc_menu_object()\object_area_path
        wc_work_gfx\object_add_to_quest=wc_menu_object()\object_add_to_quest
          
        
      EndIf
      
      If EventGadget()=#GAD_UP
        WC_REDRAW_MENU_ELEMENTS(#GAD_UP)
      EndIf
      
      
      If EventGadget()=#GAD_DOWN
        WC_REDRAW_MENU_ELEMENTS(#GAD_DOWN)
      EndIf
      
    
  EndSelect
    
  
  
  
EndProcedure

Procedure WC_ADD_MAP_OBJECT(_mode.l)
  ;mode = default = user input mouse x/y
  ;mode =auto = procedural routine
  Define _max.l=0
  
  ;---------------------------------------- if routine first call listobject is the right source 
  
  If ListSize(map_object())>0
    Define _proc_max.l=map_object()\object_procedural_max_objects
    Define _x.l=map_object()\_x
    Define _y.l=map_object()\_y
    Define _rx.l=map_object()\object_procedural_x_offset
    Define _ry.l=map_object()\object_procedural_y_offset
    ;-------------------------------------------------------------------------------
  EndIf


  If IsSprite(wc_work_gfx\_gfx_id) ;make shure there is data to use
    If wc_work_gfx\object_is_area=1
wc_area_offset_x.f=WindowMouseX(v_window_parent_id)-wc_x_offset.l-SpriteWidth(wc_work_gfx\_gfx_id)/2
wc_area_offset_y.f=WindowMouseY(v_window_parent_id)-wc_y_offset.l-SpriteHeight(wc_work_gfx\_gfx_id)/2
      WC_ADD_AREA(#WC_SILENT)
      ProcedureReturn
    EndIf
    
    
    If _mode.l=#WC_DEFAULT
      
      If AddElement(map_object())
        map_object()\_gfx_id=CopySprite(wc_work_gfx\_gfx_id,#PB_Any)
        map_object()\_x=WindowMouseX(v_window_parent_id)-wc_x_offset.l-SpriteWidth(wc_work_gfx\_gfx_id)/2
        map_object()\_y=WindowMouseY(v_window_parent_id)-wc_y_offset.l-SpriteHeight(wc_work_gfx\_gfx_id)/2
        map_object()\_ai_path=wc_work_gfx\_ai_path
        map_object()\_layer=wc_layer.b
        map_object()\_full_screen=wc_work_gfx\_full_screen
        map_object()\_transparency=255-wc_work_gfx\_transparency
        map_object()\_object_auto_layer=wc_work_gfx\_object_auto_layer
        map_object()\_DO_NOT_SAVE_THIS_OBJECT=wc_work_gfx\_DO_NOT_SAVE_THIS_OBJECT
        map_object()\_DO_NOT_SHOW=#False
        map_object()\_alpha_blend=wc_work_gfx\_alpha_blend
        map_object()\object_is_procedural_base=wc_work_gfx\object_is_procedural_base
        ;map_object()\object_procedural_done=wc_work_gfx\object_procedural_done
        map_object()\object_procedural_seed=wc_work_gfx\object_procedural_seed
        map_object()\object_procedural_source_name=wc_work_gfx\object_procedural_source_name
        map_object()\object_procedural_x_offset=wc_work_gfx\object_procedural_x_offset
        map_object()\object_procedural_y_offset=wc_work_gfx\object_procedural_y_offset
        map_object()\object_procedural_max_objects=wc_work_gfx\object_procedural_max_objects ;here we set the max value from the object(source) it is only used if manual placed, so we do not loop forever if autoplaced object is a proceduralgenerator
        map_object()\object_use_random_angle=wc_work_gfx\object_use_random_angle   
        map_object()\object_use_shadow=wc_work_gfx\object_use_shadow
        map_object()\object_shadow_intense=wc_work_gfx\object_shadow_intense
        map_object()\object_add_to_quest=wc_work_gfx\object_add_to_quest
        RotateSprite(map_object()\_gfx_id,Random(wc_work_gfx\object_use_random_angle),#PB_Absolute)

        
        ;here we can correct the layer (we use auto layer for building the map):
        If wc_use_auto_layer.b=#True
          map_object()\_layer=wc_work_gfx\_object_auto_layer
        EndIf
        
               
        If map_object()\_full_screen=#True
           ZoomSprite(map_object()\_gfx_id,wc_engine_screen_width.l,wc_engine_screen_height.l)
          map_object()\_x=0
          map_object()\_y=0
        EndIf
       ; WC_SETUP_FOR_AREA_SNAP_SHOT()
        WC_SAVE_WORLD(#USE_CACHE)
      EndIf
      
      EndIf ;element
      
    EndIf ;default
  
 ;------------------------------------------ 
  
    If _mode.l=#WC_AUTO_PLACE
      
      map_object()\object_procedural_done=#True
      
    While _max.l<_proc_max.l
      
      If AddElement(map_object())
        
        map_object()\_gfx_id=CopySprite(wc_work_gfx\_gfx_id,#PB_Any)
        map_object()\_x=_x.l+Random(_rx.l)-SpriteWidth(wc_work_gfx\_gfx_id)/2
        map_object()\_y=_y.l+Random(_ry.l)-SpriteHeight(wc_work_gfx\_gfx_id)/2
        map_object()\_ai_path=wc_work_gfx\_ai_path
        map_object()\_layer=wc_work_gfx\_object_auto_layer
        wc_layer= map_object()\_layer
        map_object()\_full_screen=wc_work_gfx\_full_screen
        map_object()\_transparency=255-wc_work_gfx\_transparency
        map_object()\_DO_NOT_SAVE_THIS_OBJECT=wc_work_gfx\_DO_NOT_SAVE_THIS_OBJECT
        map_object()\_DO_NOT_SHOW=#False
        map_object()\_alpha_blend=wc_work_gfx\_alpha_blend
        map_object()\object_is_procedural_base=wc_work_gfx\object_is_procedural_base
        map_object()\object_procedural_seed=wc_work_gfx\object_procedural_seed
        map_object()\object_procedural_source_name=wc_work_gfx\object_procedural_source_name
        map_object()\object_procedural_x_offset=wc_work_gfx\object_procedural_x_offset
        map_object()\object_procedural_y_offset=wc_work_gfx\object_procedural_y_offset
        map_object()\object_use_shadow=wc_work_gfx\object_use_shadow
        map_object()\object_shadow_intense=wc_work_gfx\object_shadow_intense
        map_object()\object_use_random_angle=wc_work_gfx\object_use_random_angle  
        map_object()\object_add_to_quest=wc_work_gfx\object_add_to_quest
        RotateSprite(map_object()\_gfx_id,Random(wc_work_gfx\object_use_random_angle),#PB_Absolute)
        
        If map_object()\_full_screen=#True
         ZoomSprite(map_object()\_gfx_id,wc_engine_screen_width.l,wc_engine_screen_height.l)
          map_object()\_x=0
          map_object()\_y=0
        EndIf
        WC_SAVE_WORLD(#USE_CACHE)
      EndIf 
    
    _max.l+1
  Wend; add
  
EndIf ;mode


  
EndProcedure


  


Procedure WC_PARENT_WINDOW_EVENT(_event.l)
  Define _msg.l=0
  
  Select _event.l
      
    Case #PB_Event_CloseWindow
      
        _msg.l=MessageRequester("QUIT WORLDCREATOR?","QUIT?",#PB_MessageRequester_YesNo)
      
        If _msg.l=#PB_MessageRequester_Yes
          
        WC_CLEAN_CACHE( v_clean_cache_on_exit.b)
         End
       
      EndIf
  
        
      Case #PB_Event_MaximizeWindow
       WC_SHOW_MAIN_SCREEN()
        
      Case #PB_Event_Menu
        WC_MENU_EVENT()
  
    
  Case #PB_Event_LeftClick
        WC_ADD_MAP_OBJECT(#WC_DEFAULT)
    
  Case #PB_Event_RightClick
        WC_DELETE_MAP_OBJECT()  

      
      EndSelect    
  EndProcedure

Procedure WC_EVENT(_event.l)
  
  Select EventWindow()
    Case v_window_parent_id
      WC_PARENT_WINDOW_EVENT(_event.l)
      
    Case v_window_child_id
      WC_MENU_WINDOW_EVENT(_event.l)
      
  EndSelect
  
  
EndProcedure


Procedure WC_KEYBOARD(_event_window.l)

  
  ExamineKeyboard()
  
  If _event_window.l=v_window_parent_id
    
    If KeyboardReleased(#PB_Key_Add)
    WC_TEMPLATE_TRANSPARENCY_ADD()  
    EndIf
    
        If KeyboardReleased(#PB_Key_Subtract)
        WC_TEMPLATE_TRANSPARENCY_REMOVE()  
    EndIf
    
    
    If   wc_map_move_per_pixel=#False
      
      If KeyboardReleased(#PB_Key_Left)
        wc_x_offset+wc_work_with.l
      EndIf
      
      If KeyboardReleased(#PB_Key_Right)
        wc_x_offset-wc_work_with.l
      EndIf
      
      
      If KeyboardReleased(#PB_Key_Up)
        wc_y_offset-wc_work_height.l
      EndIf
      
      If KeyboardReleased(#PB_Key_Down)
        wc_y_offset+wc_work_height.l
      EndIf
      
      If KeyboardReleased(#PB_Key_Return)
                WC_ADD_MAP_OBJECT(#WC_DEFAULT)
      EndIf
      
      
      If KeyboardReleased(#PB_Key_U)
        WC_MAP_OBJECT_UNDO()  
      EndIf
      
      
      
      If KeyboardReleased(#PB_Key_R)
        WC_MAP_OBJECT_REDO()  
      EndIf
      
    EndIf
    
    ;-----------------------
    
    If   wc_map_move_per_pixel=#True
      
      If KeyboardReleased(#PB_Key_Left)
        wc_x_offset+1
      EndIf
      
      If KeyboardReleased(#PB_Key_Right)
        wc_x_offset-1
      EndIf
      
      
      If KeyboardReleased(#PB_Key_Up)
        wc_y_offset+1
      EndIf
      
      If KeyboardReleased(#PB_Key_Down)
        wc_y_offset-1
      EndIf
      
      If KeyboardReleased(#PB_Key_Return)
        
        WC_ADD_MAP_OBJECT(#WC_DEFAULT)
      EndIf
      
      
      If KeyboardReleased(#PB_Key_U)
        WC_MAP_OBJECT_UNDO()  
      EndIf
      
    EndIf
    
    
    ;-------------------- if there is no object for map building  
    If wc_work_with.l=<1
      If KeyboardPushed(#PB_Key_Left)
                wc_x_offset+1
      EndIf
      
      If KeyboardPushed(#PB_Key_Right)
        wc_x_offset-1
      EndIf
    EndIf
    
    
    If wc_work_height.l<1
      
      If KeyboardPushed(#PB_Key_Up)
        wc_y_offset+1
      EndIf
      
      If KeyboardPushed(#PB_Key_Down)
        wc_y_offset-1
      EndIf
      
      
    EndIf
    ;------------------------------------------------------------------ 
    
  EndIf
  
  
EndProcedure
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 417
; FirstLine = 397
; Folding = -------
; EnableXP
; EnableUser
; CPU = 1
; DisableDebugger
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant