﻿
;object structure 
;used in object pool for creation


Structure wc_work_gfx_s
  _gfx_id.l
  _gfx_path.s
  _ai_path.s
  _full_screen.b
  _raster_x.l
  _raster_y.l
  _transparency.l
  _object_auto_layer.b ;internal use!
  _DO_NOT_SAVE_THIS_OBJECT.b
  _alpha_blend.l
  object_is_procedural_base.b ; parentobject like stone, mud, .... is need as base for automatic generated objects
  object_procedural_seed.l    ;random seed (0=nothing) random result of 1= place procedural object (100=chance 1 of 100 to place object)
  object_procedural_max_objects.l 
  object_procedural_source_name.s;holds the name of the sourcefile (its the internal objectname)
  object_procedural_done.b       ;is set to 1 (#true) if object placement is finished, so this object will not generate more foliage.
  object_procedural_x_offset.f   ;for random placement (fill it with a number from 0 to x )
  object_procedural_y_offset.f  
  object_internal_name.s
  object_use_random_angle.f
  object_use_shadow.b
  object_shadow_intense.l
  object_is_area.b
  object_area_42_path.s
  object_area_path.s
  object_add_to_quest.b
  EndStructure 




Structure menu_objects
  _gfx_id.l   ;id for the image
  _gfx_path.s ;path for the gfx file
  _ai_path.s
  _x.l
  _y.l
  _type.s  ;png, tiff,bmb
  _full_screen.b   ; true/false
  _transparency.l
  _object_auto_layer.b ;internal use!
  _DO_NOT_SAVE_THIS_OBJECT.b
  _alpha_blend.l
  _w.f
  _h.f
  object_is_procedural_base.b ; parentobject like stone, mud, .... is need as base for automatic generated objects
  object_procedural_seed.l    ;random seed (0=nothing) random result of 1= place procedural object (100=chance 1 of 100 to place object)
  object_procedural_source_name.s;holds the name of the sourcefile (its the internal objectname)
  object_procedural_done.b       ;is set to 1 (#true) if object placement is finished, so this object will not generate more foliage.
  object_procedural_x_offset.f   ;for random placement (fill it with a number from 0 to x )
  object_procedural_y_offset.f  
  object_internal_name.s
  object_gadget_id.l
  object_procedural_max_objects.l
  object_use_random_angle.f
  object_use_shadow.b
  object_shadow_intense.l
  object_is_area.b
  object_area_42_path.s
  object_area_path.s
  object_intensity.b  ;used for some gadgetsort (default=0, area=1 )  ;we sort by intensity... 0....1.......2....x
  object_add_to_quest.b
EndStructure
;--------------------------------------------------------------------------------------------------------------------------



;-------------------------THE WORCSPACE FOR MAPCREATION STORES THE COMPLETE MAP

Structure map_objects
  _gfx_id.l
  _ai_path.s
  _x.l
  _y.l
  _layer.b ;up to 128 layers (0....127)
  _full_screen.b
  _transparency.l
  _object_auto_layer.b ;internal use!
  _DO_NOT_SAVE_THIS_OBJECT.b
  _DO_NOT_SHOW.b  ;redo/undo
  _alpha_blend.l
  object_is_procedural_base.b ; parentobject like stone, mud, .... is need as base for automatic generated objects
  object_procedural_seed.l    ;random seed (0=nothing) random result of 1= place procedural object (100=chance 1 of 100 to place object)
  object_procedural_max_objects.l
  object_procedural_source_name.s;holds the name of the sourcefile (its the internal objectname)
  object_procedural_done.b       ;is set to 1 (#true) if object placement is finished, so this object will not generate more foliage.
  object_procedural_x_offset.f   ;for random placement (fill it with a number from 0 to x )
  object_procedural_y_offset.f  
  object_internal_name.s
  object_use_random_angle.f
  object_use_shadow.b
  object_shadow_intense.l
  object_add_to_quest.b
EndStructure

Structure template  ;used  for mapbuilding, you can use a gfx/sketch to help you build the map
  x.f
  y.f
  transparency.l
  id.i
  show.b
  is_valid.b
EndStructure


Structure  wc_screen_output  ;here we store the screen gfx 
id.i    
transparency.l
show.b
is_valid.b
x.f
y.f
EndStructure 


;---------------------------------------------------------------------------------

Global  wc_template.template
Global NewList wc_menu_object.menu_objects()
Global NewList map_object.map_objects()
Global wc_work_gfx.wc_work_gfx_s
Global wc_screen_output.wc_screen_output




Procedure E_DEFINE_BLENDING_MODE_MAP(_mode.s)
  ;go for the blending mode if object uses one?

  
  Select _mode.s
      
    Case "#PB_Sprite_BlendZero"
      
     map_object()\_alpha_blend=#PB_Sprite_BlendZero
      
    Case "#PB_Sprite_BlendOne"
      
      map_object()\_alpha_blend =#PB_Sprite_BlendOne
      
    Case "#PB_Sprite_BlendSourceColor"
      
      map_object()\_alpha_blend=#PB_Sprite_BlendSourceColor
      
    Case "#PB_Sprite_BlendInvertSourceColor"
      
      map_object()\_alpha_blend=#PB_Sprite_BlendInvertSourceColor
      
    Case "#PB_Sprite_BlendDestinationColor"
      
      map_object()\_alpha_blend=#PB_Sprite_BlendDestinationColor
      
    Case "#PB_Sprite_BlendSourceAlpha"
     map_object()\_alpha_blend=#PB_Sprite_BlendSourceAlpha
      
    Case "#PB_Sprite_BlendInvertSourceAlpha"
       map_object()\_alpha_blend=#PB_Sprite_BlendInvertSourceAlpha
      
    Case "#PB_Sprite_BlendDestinationAlpha"
      map_object()\_alpha_blend=#PB_Sprite_BlendDestinationAlpha
      
    Case "#PB_Sprite_BlendInvertDestinationAlpha"
    map_object()\_alpha_blend=#PB_Sprite_BlendDestinationAlpha
      
      
    Default 
      ;null
    map_object()\_alpha_blend=-1
      
  EndSelect
  
  
EndProcedure




Procedure E_DEFINE_BLENDING_MODE(_mode.s)
  
  
  Select _mode.s
      
    Case "#PB_Sprite_BlendZero"
      
       wc_menu_object()\_alpha_blend=#PB_Sprite_BlendZero
      
    Case "#PB_Sprite_BlendOne"
      
       wc_menu_object()\_alpha_blend =#PB_Sprite_BlendOne
      
    Case "#PB_Sprite_BlendSourceColor"
      
       wc_menu_object()\_alpha_blend=#PB_Sprite_BlendSourceColor
      
    Case "#PB_Sprite_BlendInvertSourceColor"
      
       wc_menu_object()\_alpha_blend=#PB_Sprite_BlendInvertSourceColor
      
    Case "#PB_Sprite_BlendDestinationColor"
      
       wc_menu_object()\_alpha_blend=#PB_Sprite_BlendDestinationColor
      
    Case "#PB_Sprite_BlendSourceAlpha"
      wc_menu_object()\_alpha_blend=#PB_Sprite_BlendSourceAlpha
      
    Case "#PB_Sprite_BlendInvertSourceAlpha"
       wc_menu_object()\_alpha_blend=#PB_Sprite_BlendInvertSourceAlpha
      
    Case "#PB_Sprite_BlendDestinationAlpha"
       wc_menu_object()\_alpha_blend=#PB_Sprite_BlendDestinationAlpha
      
    Case "#PB_Sprite_BlendInvertDestinationAlpha"
      wc_menu_object()\_alpha_blend=#PB_Sprite_BlendDestinationAlpha
      
      
    Default 
      ;null
     wc_menu_object()\_alpha_blend=-1
      
  EndSelect
  
  
EndProcedure






 
 Procedure WC_GETDEL_POINTER()
   
   wc_delpointer_gfx.l=LoadSprite(#PB_Any,wc_delpointer_path.s)
   
   If IsSprite(wc_delpointer_gfx.l)
     
   Else
     
     WC_ERROR(#WC_ERROR_DELPOINTER_MISSING,"CAN NOT LOAD: "+wc_delpointer_path.s) 
   EndIf
   
     
 EndProcedure
 




Procedure WC_LOAD_OBJECT_GFX()
  
  Define _ok.l
  Define _posx.l=0
  Define _posy.l=1

  UseGadgetList(WindowID(v_window_child_id))
  ;here we set the controlgadget
  ButtonGadget(#GAD_UP,1,1,62,32,"UP")
  ButtonGadget(#GAD_DOWN,64,1,62,32,"DOWN")
  ;-------------------------------------------------------
    ResetList(wc_menu_object())
    While NextElement(wc_menu_object())
   wc_menu_object()\_gfx_id=LoadImage(#PB_Any,wc_menu_object()\_gfx_path)
   If  IsImage(wc_menu_object()\_gfx_id)
  ResizeImage (wc_menu_object()\_gfx_id,wc_menu_image_size.l*DesktopResolutionX(),wc_menu_image_size.l*DesktopResolutionY())
   wc_menu_object()\_x=_posx.l*(wc_menu_image_size.l+1)
   wc_menu_object()\_y=_posy.l*(wc_menu_image_size.l+1)
   wc_menu_object()\_w=wc_menu_image_size.l
   wc_menu_object()\_h=wc_menu_image_size.l
  _ok.l=ImageGadget(ListIndex(wc_menu_object())+#LAST_UI_GADGET,wc_menu_object()\_x,wc_menu_object()\_y,wc_menu_image_size.l,wc_menu_image_size.l,ImageID(wc_menu_object()\_gfx_id),#PB_Image_Raised)
  GadgetToolTip(ListIndex(wc_menu_object())+#LAST_UI_GADGET,wc_menu_object()\_gfx_path)
  EndIf
 
  _posx.l+1
  
  If _posx.l>3
    _posx.l=0
    _posy.l+1
  EndIf
     
  Wend
    
EndProcedure

Procedure WC_SORT_GADGET_GFX()
  ;here we sort the gfx so we have "blocks of same type"
   SortStructuredList(wc_menu_object(),#PB_Sort_Descending   ,OffsetOf(menu_objects\object_intensity),TypeOf(menu_objects\object_intensity))
  EndProcedure





Procedure  WC_AREA_OBJECT_PARSER()
  Define _key.s=""
  Define _arg.s=""
  Define _ok.l=0
 
  
  _ok.l=ReadFile(#PB_Any,wc_area_container_path.s+wc_menu_object()\_ai_path) ;open the ai42 script file
    
  If IsFile(_ok.l)
   
    While Not Eof(_ok.l)
      
      _key.s=ReadString(_ok.l)
      _arg.s=ReadString(_ok.l)
      
      Select _key.s
          
        Case "object_source#"  ;here we reset the source file path, so we can use it (path is reconstructed for executing system)
          
          wc_menu_object()\_gfx_path=v_resource_path+GetFilePart(_arg.s)
          
        Case "object_full_screen.b"
                   
          wc_menu_object()\_full_screen=Val(_arg.s)
                    If wc_menu_object()\_full_screen=1
            
            wc_menu_object()\_full_screen=#True
                       
          Else
            
            wc_menu_object()\_full_screen=#False
            
          EndIf
                    
        Case "object_transparency.l"
          wc_menu_object()\_transparency=255-Val(_arg.s)
         
        Case "object_auto_layer.b"
          wc_menu_object()\_object_auto_layer=Val(_arg.s)
                    
        Case "object_alpha_blend.l"
         
          E_DEFINE_BLENDING_MODE(_arg.s)
          
           Case "object_procedural_source_name.s"
         
           wc_menu_object()\object_procedural_source_name=_arg.s
           
           
         Case "object_procedural_seed.l"
           wc_menu_object()\object_procedural_seed=Val(_arg.s)
           
         Case "object_is_procedural_base.b"
          
           wc_menu_object()\object_is_procedural_base=Val(_arg.s)
           
           If wc_menu_object()\object_is_procedural_base>0
           wc_menu_object()\object_procedural_done=#False    
           EndIf
           
         Case "object_is_area.b"
            wc_menu_object()\object_is_area=Val(_arg.s)
          
           
         Case "object_procedural_x_offset.f"
           wc_menu_object()\object_procedural_x_offset=ValF(_arg.s)
          
           
         Case "object_procedural_y_offset.f"
           wc_menu_object()\object_procedural_y_offset=ValF(_arg.s)
           
         Case "object_internal_name.s"
           wc_menu_object()\object_internal_name=_arg.s    
           
         Case "object_procedural_max_objects.l"
           wc_menu_object()\object_procedural_max_objects=Val(_arg.s)
           
           
         Case "object_use_random_angle.f"
           wc_menu_object()\object_use_random_angle=ValF(_arg.s)  ;use it for placement with different angles (bushes/trees ....)
           
         Case "object_use_shadow.b"
           wc_menu_object()\object_use_shadow=Val(_arg.s)
           
         Case "object_shadow_intense.l"
           wc_menu_object()\object_shadow_intense=Val(_arg.s)
           
          
      EndSelect
        
    Wend
    
  
    CloseFile(_ok.l)
  EndIf
 
EndProcedure

Procedure  WC_OBJECT_PARSER()
  Define _key.s=""
  Define _arg.s=""
  Define _ok.l=0
 
  
  _ok.l=ReadFile(#PB_Any,v_resource_path+wc_menu_object()\_ai_path) ;open the ai42 script file
    
  If IsFile(_ok.l)
   
    While Not Eof(_ok.l)
      
      _key.s=ReadString(_ok.l)
      _arg.s=ReadString(_ok.l)
      
      Select _key.s
          
        Case "object_source#"  ;here we reset the source file path, so we can use it (path is reconstructed for executing system)
          
          wc_menu_object()\_gfx_path=v_resource_path+GetFilePart(_arg.s)
          
        Case "object_full_screen.b"
                   
          wc_menu_object()\_full_screen=Val(_arg.s)
                    If wc_menu_object()\_full_screen=1
            
            wc_menu_object()\_full_screen=#True
                       
          Else
            
            wc_menu_object()\_full_screen=#False
            
          EndIf
                    
        Case "object_transparency.l"
          wc_menu_object()\_transparency=255-Val(_arg.s)
         
        Case "object_auto_layer.b"
          wc_menu_object()\_object_auto_layer=Val(_arg.s)
                    
        Case "object_alpha_blend.l"
         
          E_DEFINE_BLENDING_MODE(_arg.s)
          
           Case "object_procedural_source_name.s"
         
           wc_menu_object()\object_procedural_source_name=_arg.s
           
           
         Case "object_procedural_seed.l"
           wc_menu_object()\object_procedural_seed=Val(_arg.s)
           
         Case "object_is_procedural_base.b"
          
           wc_menu_object()\object_is_procedural_base=Val(_arg.s)
           
           If wc_menu_object()\object_is_procedural_base>0
           wc_menu_object()\object_procedural_done=#False    
           EndIf
           
       
         
           
         Case "object_procedural_x_offset.f"
           wc_menu_object()\object_procedural_x_offset=ValF(_arg.s)
          
           
         Case "object_procedural_y_offset.f"
           wc_menu_object()\object_procedural_y_offset=ValF(_arg.s)
           
         Case "object_internal_name.s"
           wc_menu_object()\object_internal_name=_arg.s    
           
         Case "object_procedural_max_objects.l"
           wc_menu_object()\object_procedural_max_objects=Val(_arg.s)
           
           
         Case "object_use_random_angle.f"
           wc_menu_object()\object_use_random_angle=ValF(_arg.s)  ;use it for placement with different angles (bushes/trees ....)
           
         Case "object_use_shadow.b"
           wc_menu_object()\object_use_shadow=Val(_arg.s)
           
         Case "object_shadow_intense.l"
           wc_menu_object()\object_shadow_intense=Val(_arg.s)
           
           
         Case "object_add_to_quest.b"
           wc_menu_object()\object_add_to_quest=Val(_arg.s)
           
       ;areas    
           
             Case "object_is_area.b"
           wc_menu_object()\object_is_area=Val(_arg.s)
           
         Case "object_area_ai42_path.s"
           wc_menu_object()\object_area_42_path=_arg.s
           
         Case "object_area_path.s"
           wc_menu_object()\object_area_path=_arg.s
           
         Case "object_intensity.b"
           wc_menu_object()\object_intensity=Val(_arg.s)
                    
      EndSelect
        
    Wend
    
  
    CloseFile(_ok.l)
  EndIf
 
EndProcedure




Procedure WC_OBJECT_FILE_MERGER()
  
  ResetList(wc_menu_object()) ;start with the first entry
  
  ;here we read the AI42 file for some information we need in the worldcreator for objectpositioning and display
  
  While NextElement(wc_menu_object())
    WC_OBJECT_PARSER()
     Wend
  

EndProcedure






Procedure WC_SET_RESOURCE()
  Define _path.s=""
  Define _ok.l=0
  
  _path.s=PathRequester("SET RESOURCE PATH",v_resource_path.s)
  
  If _path.s>""
    
    _ok.l=CreateFile(#PB_Any,v_base.s+v_resource_name.s)
    WriteString(_ok.l,_path.s)
    CloseFile(_ok.l)
    _ok.l=MessageRequester("WORLD CREATOR: RESOURCE FILES:",_path.s+Chr(13)+"WORLDCREATOR MUST QUIT AND RESTART",#PB_MessageRequester_Ok)
    
    End
    
  Else
    
    _ok.l=MessageRequester("WORLD CREATOR: RESOURCE FILES:","NOT DEFINED/NOT CHANGED"+Chr(13)+"******IGNORE NEXT ERROR*****",#PB_MessageRequester_Ok)
     wc_ignore_map_error.b=#True
    
  EndIf
 
  EndProcedure




Procedure WC_CHECK_RESOURCE()
  
  Define _ok.l=0
  
  _ok.l=ReadFile(#PB_Any,v_resource_name.s)
  
  If IsFile(_ok.l)
    
    v_resource_path.s=ReadString(_ok.l) ;is stored in the first line (only line) of resource file
           
  Else
    
    If wc_ignore_map_error.b=#False
   WC_ERROR(#WC_ERROR_NEED_SOURCE,"WARNING! NO GFX / OBJECT SOURCE")
   WC_SET_RESOURCE()
 EndIf
 
   
  EndIf
    
  CloseFile(_ok.l)
     
  EndProcedure
  
  
  Procedure WC_LIST_RESOURCE_DIRECTORY()
    Define _file.l=0
    Define _dir.l=0
    
     
    ClearList(wc_menu_object())
    ResetList(wc_menu_object())
    
    _dir.l=ExamineDirectory(#PB_Any,v_resource_path,v_resource_type)
    
    While NextDirectoryEntry(_dir.l)
      
      
      If DirectoryEntryType(_dir.l)=#PB_DirectoryEntry_File
   
        
        If AddElement(wc_menu_object())
          
           wc_menu_object()\_ai_path  = DirectoryEntryName(_dir.l)
        
      EndIf
  EndIf
     
Wend
FinishDirectory(_dir.l)

    
  EndProcedure
  
  
  
  
  
  
  
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 483
; FirstLine = 451
; Folding = --
; EnableXP
; EnableUser
; CPU = 1
; DisableDebugger